//---------------------------------------------------------------------------

#ifndef UMainH
#define UMainH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <Menus.hpp>
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>
#include "Sprites.h"
#include <Dialogs.hpp>
//---------------------------------------------------------------------------
class TMain : public TForm
{
__published:	// IDE-managed Components
  TMainMenu *MainMenu;
  TMenuItem *MainMenuFile;
  TMenuItem *MainMenuExit;
  TMenuItem *MainMenuHelp;
  TMenuItem *MainMenuAbout;
  TPaintBox *SpriteList;
  TStatusBar *StatusBar;
  TScrollBar *SpriteListBar;
  TMenuItem *MainMenuNew;
  TMenuItem *MainMenuOpen;
  TMenuItem *MainMenuSave;
  TMenuItem *MainMenuSaveAs;
  TMenuItem *N1;
  TMenuItem *MainMenuEdit;
  TMenuItem *MainMenuCut;
  TMenuItem *MainMenuCopy;
  TMenuItem *MainMenuPaste;
  TMenuItem *MainMenuDelete;
  TMenuItem *N3;
  TMenuItem *MainMenuInsert;
  TGroupBox *SpriteInfo;
  TEdit *SpriteInfoEditWidth;
  TLabel *SpriteInfoLabelWidth;
  TLabel *SpriteInfoLabelHeight;
  TEdit *SpriteInfoEditHeight;
  TLabel *SpriteInfoLabelAnim;
  TLabel *SpriteInfoLabelFrames;
  TEdit *SpriteInfoEditAnim;
  TEdit *SpriteInfoEditFrames;
  TButton *SpriteInfoEditUpdate;
  TGroupBox *SpriteViewBox;
  TPaintBox *SpriteView;
  TButton *ButtonAnimate;
  TTimer *Timer;
  TMenuItem *MainMenuView;
  TMenuItem *MainMenuScaled;
  TMenuItem *MainMenuNormal;
  TLabel *SpriteInfoLabelTrans;
  TPaintBox *SpriteInfoEditTransColor;
  TCheckBox *SpriteInfoEditTrans;
  TMenuItem *N2;
  TMenuItem *MainMenuMerge;
  TUpDown *SpriteInfoEditAnimUD;
  TUpDown *SpriteInfoEditFramesUD;
  TSaveDialog *SaveDialog;
  TOpenDialog *OpenDialog;
  TMenuItem *MainMenuClose;
  TLabel *SpriteInfoLabelName;
  TEdit *SpriteInfoEditName;
  TMenuItem *N4;
  TMenuItem *MainMenuExport;
  TMenuItem *ExportMenuDefine;
  TMenuItem *ExportMenuEnum;
  TSaveDialog *ExportDialog;
  TMenuItem *N5;
  void __fastcall MainMenuExitClick(TObject *Sender);
  void __fastcall MainMenuAboutClick(TObject *Sender);
  void __fastcall MainMenuNewClick(TObject *Sender);
  void __fastcall FormCreate(TObject *Sender);
  void __fastcall FormCloseQuery(TObject *Sender, bool &CanClose);
  void __fastcall MainMenuOpenClick(TObject *Sender);
  void __fastcall SpriteListPaint(TObject *Sender);
  void __fastcall MainMenuInsertClick(TObject *Sender);
  void __fastcall SpriteListBarChange(TObject *Sender);
  void __fastcall SpriteListMouseDown(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
  void __fastcall MainMenuDeleteClick(TObject *Sender);
  void __fastcall MainMenuSaveAsClick(TObject *Sender);
  void __fastcall MainMenuCopyClick(TObject *Sender);
  void __fastcall MainMenuCutClick(TObject *Sender);
  void __fastcall MainMenuPasteClick(TObject *Sender);
  void __fastcall FormClick(TObject *Sender);
  void __fastcall MainMenuEditClick(TObject *Sender);
  void __fastcall SpriteInfoEditUpdateClick(TObject *Sender);
  void __fastcall SpriteViewPaint(TObject *Sender);
  void __fastcall ButtonAnimateClick(TObject *Sender);
  void __fastcall TimerTimer(TObject *Sender);
  void __fastcall MainMenuScaledClick(TObject *Sender);
  void __fastcall MainMenuNormalClick(TObject *Sender);
  void __fastcall SpriteInfoEditTransColorPaint(TObject *Sender);
  void __fastcall SpriteViewMouseDown(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
  void __fastcall MainMenuSaveClick(TObject *Sender);
  void __fastcall MainMenuFileClick(TObject *Sender);
  void __fastcall MainMenuMergeClick(TObject *Sender);
  void __fastcall MainMenuCloseClick(TObject *Sender);
  void __fastcall FormDestroy(TObject *Sender);
  void __fastcall ExportMenuDefineClick(TObject *Sender);
  void __fastcall ExportMenuEnumClick(TObject *Sender);
private:	// User declarations
  bool _CheckSave();
  void _UpdateMenu();
  void _UpdateSpriteList();
  bool _modified,
       _animating;
  int _transcolor;
  Sprites _sprites;
  Graphics::TBitmap *_sprlist;
  int _selected,
      _animate;  
  AnsiString _filename;
public:		// User declarations
  __fastcall TMain(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TMain *Main;
//---------------------------------------------------------------------------
#endif
